
package de.ivu.elect.presentation.statistik.exchange;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.exchange.control.AbstractExporter;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.statistik.boundary.StatistikLaufExporter;
import de.ivu.elect.business.statistik.control.StatistikLaufExportContext;
import de.ivu.elect.business.statistik.entity.StatistikLauf;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.exchange.AbstractExportSearchView;
import de.ivu.elect.presentation.exchange.ExportDescription;

@Named(StatistikLaufExportView.COMPONENT_NAME)
@View(viewId = StatistikLaufExportView.VIEW_ID, useCase = UseCasePermission.STATISTIK_LAUF_EXPORTIEREN)
public class StatistikLaufExportView extends AbstractExportSearchView<List<StatistikLauf>, StatistikLaufExportContext> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "statistikLaufExportView";

  public static final String VIEW_ID = "/statistik/statistik-lauf-export.xhtml";

  @Inject
  private transient StatistikLaufExporter exporter;

  @Inject
  private transient StatistikLaufExportDescription exportDescription;

  private List<StatistikLauf> statistikLaeufe = new ArrayList<>();

  public StatistikLaufExportView() {
    super();
  }

  @Override
  protected AbstractExporter<List<StatistikLauf>, StatistikLaufExportContext> getExporter() {
    return exporter;
  }

  @Override
  protected StatistikLaufExportContext getContext() {
    return new StatistikLaufExportContext(getSelectedWahltermin(), getSelectedWahl(), getStatistikLaeufe());
  }

  @Override
  public ExportDescription getExportDescription() {
    return exportDescription;
  }

  public List<StatistikLauf> getStatistikLaeufe() {
    return statistikLaeufe;
  }

  @Redirect
  public String init(List<StatistikLauf> statistikLaeufe) {
    this.statistikLaeufe = statistikLaeufe;

    return VIEW_ID;
  }
}
